///
class Report {
  ///
  const Report({
    required this.appVersion,
    required this.deviceModel,
    required this.osVersion,
    this.userId,
    this.issue,
    this.issueExplanation,
    this.feedback,
    this.rating,
  });

  ///
  factory Report.fromJson(Map<String, dynamic> json) {
    return Report(
      userId: json["userId"],
      appVersion: json["appVersion"],
      deviceModel: json["deviceModel"],
      osVersion: json["osVersion"],
      issue: json["issue"],
      issueExplanation: json["issueExplanation"],
      feedback: json["feedback"],
      rating: json["rating"],
    );
  }

  ///
  final String? userId;

  ///
  final String appVersion;

  ///
  final String deviceModel;

  ///
  final String osVersion;

  ///
  final String? issue;

  ///
  final String? issueExplanation;

  ///
  final String? feedback;

  ///
  final int? rating;

  ///
  Map<String, dynamic> toJson() {
    return {
      "userId": userId,
      "appVersion": appVersion,
      "deviceModel": deviceModel,
      "osVersion": osVersion,
      "issue": issue,
      "issueExplanation": issueExplanation,
      "feedback": feedback,
      "rating": rating,
    };
  }

  ///
  Report copyWith({
    String? userId,
    String? appVersion,
    String? deviceModel,
    String? osVersion,
    String? issue,
    String? issueExplanation,
    String? feedback,
    int? rating,
  }) {
    return Report(
      userId: userId ?? this.userId,
      appVersion: appVersion ?? this.appVersion,
      deviceModel: deviceModel ?? this.deviceModel,
      osVersion: osVersion ?? this.osVersion,
      issue: issue ?? this.issue,
      issueExplanation: issueExplanation ?? this.issueExplanation,
      feedback: feedback ?? this.feedback,
      rating: rating ?? this.rating,
    );
  }
}
