import "package:feedback_repository_interface/src/interfaces/feedback_repository_interface.dart";
import "package:feedback_repository_interface/src/local/local_feedback_repository.dart";
import "package:feedback_repository_interface/src/models/report.dart";

///
class FeedbackService {
  ///
  FeedbackService({
    FeedbackRepositoryInterface? feedbackRepository,
  }) : feedbackRepository = feedbackRepository ?? LocalFeedbackRepository();

  ///
  final FeedbackRepositoryInterface feedbackRepository;

  ///
  Future<void> sendFeedback({required Report feedback}) async {
    await feedbackRepository.sendFeedback(feedback: feedback);
  }

  ///
  Future<void> sendReport({required Report report}) async {
    await feedbackRepository.sendReport(report: report);
  }

  ///
  Future<bool> shouldShowFeedbackPopup({required int showCount}) async {
    return feedbackRepository.shouldShowFeedbackPopup(showCount: showCount);
  }

  ///
  Future<void> addViewCount() async {
    await feedbackRepository.addViewCount();
  }
}
